<?php
/* --------------------------------------------------------------
   Amazon Pay  V3.1.0
   checkout_amazon_wallet.php 2017-02-10

   alkim media
   http://www.alkim.de

   patworx multimedia GmbH
   http://www.patworx.de/

   Released under the GNU General Public License
--------------------------------------------------------------
*/
?><?php
include('includes/application_top.php');
include_once(DIR_FS_CATALOG.'AmazonLoginAndPay/.config.inc.php');

// Check if Amazon ID is set and Amazon is allowed
if ((isset($_SESSION['amazon_id'])) && ($_SESSION['amazon_id'] != '') && (MODULE_PAYMENT_AM_APA_STATUS == 'True')) {
    $amazon_id = $_SESSION['amazon_id'];
} else {
    xtc_redirect(xtc_href_link(FILENAME_SHOPPING_CART));
}

if($_GET["action"] == 'confirm_payment'){
    $_GET["amz"] = 1;
    $confirmation = AlkimAmazonHandler::call('confirmOrderReference', array('amazon_order_reference_id'=>$amazon_id));
    if(isset($confirmation["Error"])){
        xtc_redirect(xtc_href_link('checkout_amazon_wallet.php', 'payment_error=1'));
    }
    include(DIR_FS_CATALOG.FILENAME_CHECKOUT_PROCESS);
}

$_SESSION["fromWallet"] = 1;
$breadcrumb->add(AMAZON_CHECKOUT, xtc_href_link('checkout_amazon.php', '', 'SSL'));
// create smarty elements
$smarty              = new Smarty;
// include boxes
require(DIR_FS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/source/boxes.php');
// include needed functions

if(!empty($_GET["payment_error"])){
    $smarty->assign('ERROR', TEXT_AMZ_PAYMENT_METHOD_NOT_ALLOWED);
}
$smarty->assign('BUTTON_CONTINUE', xtc_image_button('button_confirm_order.gif', IMAGE_BUTTON_CONFIRM_ORDER, ' style="cursor:pointer;" ')); 
$smarty->assign('language', $_SESSION['language']);
$smarty->caching = 0;
$main_content    = $smarty->fetch(CURRENT_TEMPLATE . '/module/checkout_amazon_wallet.html');
$smarty->assign('language', $_SESSION['language']);
$smarty->assign('main_content', $main_content);
$smarty->caching = 0;
if (!defined(RM))
    $smarty->load_filter('output', 'note');

require(DIR_WS_INCLUDES . 'header.php');
$smarty->display(CURRENT_TEMPLATE . '/index.html');
include('includes/application_bottom.php');
?>
